<template>
    <div class="w">
        <v-btn x-small @click='onAddNew'>Add New Enumeration</v-btn>
        <EnumValue class="w" v-for="(e, index) in enumlist"  :key=index :enumVal=e v-on:remove="onRemove(index)" v-on:changed="onChanged"></EnumValue>    
    </div>
</template>

<script lang="ts">
import Vue from 'vue'
import { Enum } from '../ItemData'
import EnumValue from '@/components/EnumValue.vue'

export default Vue.extend({
    props: {
        value: {
            type: Array,  
            required: true
        }
    },

    computed: {
        enumlist: {
            get: function(): Array<Enum> { return this.value as Array<Enum>; },
        }
    },    

    methods: {
        onAddNew(): void {
            this.enumlist.push(new Enum("new enum", 0));  // it just works :-O
            this.$emit('input', this.enumlist);  // note casing - it's enumList still

        },

        onRemove(index: number): void {
            this.enumlist.splice(index, 1);
            this.$emit('input', this.enumlist);  // note casing - it's enumList still
        },

        onChanged(): void {
            console.log("EnumValue muuttui...")
            this.$emit('input', this.enumlist);  // note casing - it's enumList still
        }
    },

    components: { EnumValue }

});
</script>

<style scoped>
.w {
    width: 100%;
}

</style>
